Skip to main content

Fetch Extended Transaction Data

Legacy Guide

This guide is for Platform API v2011101. For guidance on the newest version, see Connectivity Integration Guides.

Extended Transaction History (ETH) extends the Account Aggregation product from 90 days to up to 24 months, depending on the financial institution.

This guide walks through the Extended Transaction History process using API endpoints. Extended transaction data cannot be retrieved using the Connect Widget.

API Workflow

The workflow is as follows:

  1. Create a user.
  2. Search for an institution.
  3. Get the credentials required by the institution.
  4. Create a member.
  5. Poll the member's connection status.
  6. Request extended transaction history.
  7. Poll the member’s connection status again until it reaches an end state.
  • You may need to deal with Multifactor Authentication.
  • A successful end state is when the connection_status is CONNECTED and the is_aggregating field changes from true to false.
  1. List the member's account information or read a particular account's information.
  2. List the member's transaction information or read a particular transaction's information.
Step 1

Create a user

A user represents your end user in the MX Platform. Make a request to the Create User endpoint (POST /users).

We recommend that you include a unique id of your choice with the request. You may also include metadata, such as the date the user was created or the end user's name. Don't include any sensitive information here, such as credentials.

info

None of these parameters are required, but the user object can't be empty. We recommend that you always set the id parameter when creating a user.

In the response, the API gives each new user an MX-defined guid (or user_guid when appearing outside the user object). Between your id and the guid, you can map between your system and ours. You'll need the user guid for nearly every request on the MX API, at least when using basic authorization.

Request
Response
Language:shell

_12
curl -i -X POST 'https://int-api.mx.com/users' \
_12
-u 'client_id:api_key' \
_12
-H 'Accept: application/vnd.mx.api.v1+json' \
_12
-H 'Content-Type: application/json' \
_12
-d '{
_12
"user": {
_12
"id": "partner-2345",
_12
"is_disabled": false,
_12
"email": "example@example.com",
_12
"metadata": "Some metadata"
_12
}
_12
}'

Step 2

Search for an Institution

To create a member, you need to know what financial institution the member should be connected to and what type of credentials the institution expects to get.

First, search for an institution using query parameters on the list institutions endpoint, GET /institutions?name={string}&supports_transaction_history=true.

The example searches for MX Bank, which is MX's institution for testing and development. It also limits results to institutions that support ETH.

The response returns a paginated list of institutions that match the string you send in the name query parameter. Make a note of the code you find in the example response; you'll need this for the next step.

Request
Response
Language:shell

_10
curl -i 'https://int-api.mx.com/institutions?name=mx&supports_transaction_history=true' \
_10
-u 'client_id:api_key' \
_10
-H 'Accept: application/vnd.mx.api.v1+json'

Step 3

Get the Institution's Required Credentials

Each institution requires different types of credentials. Some require an email and a password, some require a username and a password, and some may require other types of credentials.

Make a request to the List Institution Credentials endpoint (GET /institutions/{institution_code}/credentials). Include the institution code retrieved from the previous step in the request path.

This endpoint returns the GUID for each required credential, which is used to match the credentials the end user provides to the required credential type when creating a member.

Request
Response
Language:shell

_10
curl -X GET https://int-api.mx.com/institutions/mxbank/credentials \
_10
-H 'Accept: application/vnd.mx.api.v1+json' \
_10
-u 'client_id:api_key'

Step 4

Create a Member

For this step, you need to have already gathered from the end user the values needed for each credential. The following example uses the MX Bank institution and therefore requires a username and a password; it sets the username to mxuser and the password to password which are the credentials for the test user for MX Bank.

Make a POST request to the /users/{user_guid}/members endpoint. The response includes the newly created member.

  • Put the user_guid in the path.
  • In the body, include the credential GUIDs and their values in the credentials array.
  • In the body, set the skip_aggregation parameter to true.
    • Standard aggregation begins automatically when a member is created unless you explicitly prevent it by using skip_aggregation. Because you are going to aggregate data using the Extended Transaction History product, you don't need to start standard aggregation.
  • In the body, set the id and metadata fields as you see fit. This is not required, but is strongly encouraged.
  • Optionally, you can disable background aggregation with the background_aggregation_is_disabled parameter. It defaults to false. In other words, background aggregation is enabled by default.

We encourage that you also poll the member using the Check Status endpoint as shown in Step 5 to be sure you can aggregate the member. For more information on Connection Status, view our Reference.

warning

Do not add multiple members that connect to the same institution using the same credentials on the same user. This will result in a 409 Conflict error.

Request
Response
Language:shell

_22
curl -i -X POST 'https://int-api.mx.com/users/USR-11141024-90b3-1bce-cac9-c06ced52ab4c/members' \
_22
-u 'client_id:api_key' \
_22
-H 'Accept: application/vnd.mx.api.v1+json' \
_22
-H 'Content-Type: application/json' \
_22
-d '{
_22
"member": {
_22
"credentials": [
_22
{
_22
"guid": "CRD-1ec152cd-e628-e81a-e852-d1e7104624da",
_22
"value": "mxuser"
_22
},
_22
{
_22
"guid": "CRD-1ec152cd-e628-e81a-e852-d1e7104624da",
_22
"value": "password"
_22
}
_22
],
_22
"id": "member-9876",
_22
"institution_code": "mxbank",
_22
"metadata": "some metadata",
_22
"skip_aggregation": true
_22
}
_22
}'

Step 5

Poll the Member's Connection Status

Check the connection status of the member to get information on the state of the aggregation. Important fields include connection_status, is_being_aggregated, and successfully_aggregated_at. The is_being_aggregated field will tell you whether the aggregation is ongoing or complete.

When you see "connection_status": "CONNECTED" and "is_being_aggregated": false at the same time, the aggregation is done and you can move on to the next step. The successfully_aggregated_at field will give the exact time the aggregate successfully completed, but won't update if the aggregation fails.

You may need to check the connection status several times until an end state is reached.

Make a request to the Read Member Status endpoint (GET /users/{user_guid}/members/{member_guid}/status). The response in the example shows a successful end state.

Request
Response
Language:shell

_10
curl -i 'https://int-api.mx.com/users/USR-11141024-90b3-1bce-cac9-c06ced52ab4c/members/MBR-3bdc7d6b-efd4-1497-a0af-b23501cf9bd0/status' \
_10
-H 'Accept: application/vnd.mx.api.v1+json' \
_10
-u 'client_id:api_key'

Step 6

Request Extended Transaction History

Make a POST request to the /users/{user_guid}/members/{member_guid}/extend_history endpoint. This request only starts the process; actually reading the aggregated data comes later. The response will be a member object with information about the state of the process you just started.

Request
Response
Language:shell

_10
curl -i -X POST 'https://int-api.mx.com/users/USR-11141024-90b3-1bce-cac9-c06ced52ab4c/members/MBR-3bdc7d6b-efd4-1497-a0af-b23501cf9bd0/extend_history' \
_10
-H 'Accept: application/vnd.mx.api.v1+json' \
_10
-H 'Content-Type: application/json' \
_10
-u 'client_id:api_key'

Step 7

Poll the Member to Check for Connection Status Again

Check the connection status of the member to get information on the state of the ETH aggregation. Important fields include connection_status, is_being_aggregated, and successfully_aggregated_at. The is_being_aggregated field will tell you whether the ETH aggregation is ongoing or complete.

When you see "connection_status": "CONNECTED" and "is_being_aggregated": false at the same time, the ETH aggregation is done and you can move on to the next step. The successfully_aggregated_at field will give the exact time the aggregate successfully completed, but won't update if the ETH aggregation fails.

You may need to check the connection status several times until an end state is reached.

Make a request to the Read Member Status endpoint (GET /users/{user_guid}/members/{member_guid}/status). The response in the example shows a successful end state.

Request
Response
Language:shell

_10
curl -i 'https://int-api.mx.com/users/USR-11141024-90b3-1bce-cac9-c06ced52ab4c/members/MBR-3bdc7d6b-efd4-1497-a0af-b23501cf9bd0/status' \
_10
-H 'Accept: application/vnd.mx.api.v1+json' \
_10
-u 'client_id:api_key'

Deal with Multifactor Authentication

ETH may trigger multifactor authentication (MFA) from the institution associated with the member. This is indicated by connection_status: CHALLENGED.

Please see the detailed section on answering MFA challenges for more information. For this part of the guide, we'll assume there was no MFA and move on to the next step.

Step 8

List Account Data

The ETH process was successful and you can now read account information.

Make a GET request to the /users/{user_guid}/members/{member_guid}/accounts endpoint. The response will include all the accounts belonging to the member.

Request
Response
Language:shell

_10
curl -i -X GET 'https://int-api.mx.com/users/USR-11141024-90b3-1bce-cac9-c06ced52ab4c/members/MBR-3bdc7d6b-efd4-1497-a0af-b23501cf9bd0/accounts' \
_10
-H 'Accept: application/vnd.mx.api.v1+json' \
_10
-u 'client_id:api_key'

info

There is another endpoint for listing accounts which may be more suitable for your use case: GET /users/{user_guid}/accounts.

You may also consider reading the attributes of a specific account. There are two endpoints for this which return the same information, provided for code convenience:

GET /users/{user_guid}/members/{member_guid}/accounts/{account_guid}

GET /users/{user_guid}/accounts/{account_guid}

Step 9

List Transaction Data

With the account GUID from the last step, make a request to the list transaction by account endpoint. To retrieve transaction history older than 90 days, set from_date to a date more than 90 days before the request. If you do not set a from_date older than 90 days, the response will include at most 90 days of transaction data available through the Account Aggregation product.

Request
Response
Language:shell

_10
curl -i -X GET 'https://int-api.mx.com/users/USR-11141024-90b3-1bce-cac9-c06ced52ab4c/members/BR-3bdc7d6b-efd4-1497-a0af-b23501cf9bd0/transactions?from_date=2020-09-20&page=1&records_per_page=10&to_date=2023-10-20' \
_10
-H 'Accept: application/vnd.mx.api.v1+json' \
_10
-u 'client_id:api_key'

Keep in mind that all list endpoints are paginated. To get the full list of transactions, you'll need to pay attention to the pagination object and make multiple requests specifying the page and the records_per_page in order to see all the available data. Notice from the pagination object in the response that there are 243 transactions in this account and that the endpoint returned the first 10 of these.

There are several other endpoints that can give you access to transaction data: list transactions by user and list transactions by member. These work in the same way as the list transactions by account endpoint.